//Za pocetak ignorisati vrijesnoti za padding, margin i slicno.
//Ignorisati i eventualno povaljanje elemenata.
//Ignorisati i sve osim prvo ancestora

//Fokusirati se na vlastiti osobine, koje trebaju biti ispravne jer nehendlam sve
//rubne slucajeve.
//Pokusati uraditi za layout red i column, tj. da ima neki propery.

import 'package:equatable/equatable.dart';
import 'package:apply/core/config/plugin_config.dart';
import 'package:apply/core/range.dart';
import 'package:apply/core/value.dart';
import 'package:apply/elements/element_class.dart';

abstract class Plugin with EquatableMixin {
  final List<Range> ranges = [];
  final List<Range> cRanges = [];

  List<Range> get allRanges => [...cRanges, ...ranges];
  final values = ValuesList();

  String get id;

  // List<String> get keys;
  bool matches(String key) => ranges.hasMatch(key);

  Plugin createInstance(ElementClass elementClass);

  void addValue(String? value) {
    if (value != null) {
      values.add(allRanges.keyToValue(value));
    }
  }

  void update(ElementClass elementClass) {
    addValue(elementClass.value);
    // print(["radim update", elementClass.value, elementClass.value]);
  }

  @override
  String toString() => 'Plugin{ $id}';

  @override
  List<Object> get props => [id];

  void setConfig() => config = PluginConfig.withSizingConfig(
      Map<String, dynamic>.from(defaultConfig['sizing'] ?? {})..addAll(PluginConfig.userConfiguration[id] ?? {}));

  Map<String, dynamic> defaultConfig = {};
  late PluginConfig config;
}
