import 'package:apply/core/config/plugin_config.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/plugins/align_items.dart';
import 'package:apply/plugins/animation.dart';
import 'package:apply/plugins/background_color.dart';
import 'package:apply/plugins/background_image.dart';
import 'package:apply/plugins/background_opacity.dart';
import 'package:apply/plugins/background_size.dart';
import 'package:apply/plugins/border_color.dart';
import 'package:apply/plugins/border_radius.dart';
import 'package:apply/plugins/border_width.dart';
import 'package:apply/plugins/box_shadow.dart';
import 'package:apply/plugins/display.dart';
import 'package:apply/plugins/flex_direction.dart';
import 'package:apply/plugins/flex_grow.dart';
import 'package:apply/plugins/flex_wrap.dart';
import 'package:apply/plugins/font-weight.dart';
import 'package:apply/plugins/font_family.dart';
import 'package:apply/plugins/font_size.dart';
import 'package:apply/plugins/gradient_color_stops.dart';
import 'package:apply/plugins/grid.dart';
import 'package:apply/plugins/height.dart';
import 'package:apply/plugins/justify_content.dart';
import 'package:apply/plugins/letter_spacing.dart';
import 'package:apply/plugins/line_height.dart';
import 'package:apply/plugins/margin.dart';
import 'package:apply/plugins/object-position.dart';
import 'package:apply/plugins/opacity.dart';
import 'package:apply/plugins/overflow.dart';
import 'package:apply/plugins/padding.dart';
import 'package:apply/plugins/position/position.dart';
import 'package:apply/plugins/space.dart';
import 'package:apply/plugins/text_align.dart';
import 'package:apply/plugins/text_color.dart';
import 'package:apply/plugins/text_decoration.dart';
import 'package:apply/plugins/text_opacity.dart';
import 'package:apply/plugins/transform.dart';
import 'package:apply/plugins/width.dart';

//
class PluginsService {
  static Set<Plugin>? _plugins;

  static Set<Plugin> get $ => _plugins ??= _getPlugins();

  static Plugin? findByKey(String key) {
    var iterable = $.where((p) => p.matches(key));
    // return iterable.first;
    return iterable.length > 0 ? iterable.first : null;
  }

  static Plugin? findById(String id) {
    var iterable = $.where((p) => p.id == id);
    // return iterable.first;
    return iterable.length > 0 ? iterable.first : null;
  }
}

Set<Plugin> _getPlugins() {
  Map<String, Map<String, dynamic>> _userConfig = {
    'borderRadius': {
      'xxxl': 5,
      // 'base' : 44,
    }
  };
  PluginConfig.configure(_userConfig);
  return Set.from(
    [
      // AnimationP(),
      ObjectPosition(),
      BorderRadiusP(),
      BorderWidth(),
      BorderColor(),
      Display(),
      FlexDirection(),
      FlexWrap(),
      BoxShadowP(),
      FlexGrow(),
      JustifyContent(),
      OverflowP(),
      Margin(),
      Position.create(),
      AlignItems(),
      PaddingP(),
      BackgroundImage(),
      GradientColorStops(),
      Height(),
      Width(),
      BackgroundSize(),
      //
      FontWeightP(),
      FontFamily(),
      FontSize(),
      LineHeight(),
      TextAlignP(),
      TextColorP(),
      TextOpacity(),
      TextDecorationP(),
      LetterSpacing(),
      //
      BackgroundColor(),
      TransformP(),
      OpacityP(),
      BackgroundOpacity(),

      GridP(),
      Space(),
    ],
  );
}
