import 'package:apply/core/value.dart';

class Range {
  final RegExp regex;
  final int id;

  Range(this.regex, [this.id = 0]);
}

extension ExtRange on List<Range> {
  bool hasMatch(String key) {
    for (var range in this) {
      if (range.regex.hasMatch(key)) {
        return true;
      }
    }
    return false;
  }

  Value keyToValue(String key) {
    for (var range in this) {
      if (range.regex.hasMatch(key)) {
        return Value(key, range.id);
      }
    }
    throw "Wrong data $key";
  }
}
