import 'package:apply/core/plugin.dart';
import 'package:apply/core/plugins_service.dart';
import 'package:apply/elements/element_class.dart';

class Attributes {
  final List<ElementClass> classes;

  Attributes._(this.classes);

  factory Attributes.fromParts(List<String> parts){
    final List<ElementClass> classes = [];
    for (var part in parts) {
      String value;
      String key;
      value = part;

    key = value;
    classes.add(ElementClass(
      value: value,
      key: key,
    ));

    }

    return Attributes._(classes);

  }


  Set<Plugin> getAppliedPlugins([List<Plugin> fromParent = const []]){
    final plugins = Set<Plugin>.from(fromParent);
    for(var _class in classes){
      var plugin = PluginsService.findByKey(_class.key);
      if (plugin != null) {
        if(plugins.contains(plugin)){
          var pluginToUpdate = plugins.lookup(plugin);
          pluginToUpdate?.update(_class);
        }else{
          var newPlugin = plugin.createInstance(_class);
          plugins.add(newPlugin);
        }
      }
    }
    return plugins;
  }

  @override
  String toString() => 'Element{,\n allMatches: $classes}';
}
