import 'package:apply/core/framework.dart';
import 'package:apply/elements/div.dart';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';

class P extends StatelessWidget {
  final String text;
  final String style;

  P(
    this.text, {
    this.style = "",
  });

  @override
  Widget build(BuildContext context) => Div(
        style: style,
        child: _P(text),
      );

// static Pair<TextAlign, TextStyle> getTextStyle(BuildContext context) => _getTextStyle(context)!;
}

class _P extends StatelessWidget {
  final String text;

  _P(this.text);

  @override
  Widget build(BuildContext context) {
    var textStyle = context.getTextStyle();

    return Text(
      text,
      style: textStyle.last,
      textAlign: textStyle.first,
    );
  }
}

typedef TextStyle TextStyleBuilder(TextStyle textStyle);

class Span extends StatelessWidget {
  final String text;
  final String style;
  final List<Span> children;
  final TextStyleBuilder? textStyleBuilder;

  Span(
    this.text, {
    this.style = "",
    this.children = const [],
    this.textStyleBuilder,
  });

  @override
  Widget build(BuildContext context) => Div(
        style: style,
        child: _Span(
          text,
          children: children,
        ),
      );

  InlineSpan asInlineSpan(Pair<TextAlign, TextStyle> textStyle) => TextSpan(
        text: text,
        style: textStyleBuilder != null ? textStyleBuilder!(textStyle.last!) : textStyle.last,);
}


class _Span extends StatelessWidget {
  final String text;
  final List<Span> children;

  _Span(
    this.text, {
    this.children = const [],
  });

  @override
  Widget build(BuildContext context) {
    var textStyle = context.getTextStyle();

    return RichText(
      text: TextSpan(
        text: text,
        style: textStyle.last,
        children: children.map((e) => e.asInlineSpan(textStyle)).toList(growable: false),
      ),
      textAlign: textStyle.first ?? TextAlign.start,
    );
  }
}
