import 'package:flutter/material.dart';
import 'package:apply/core/framework.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/plugins/transform.dart';
import 'package:apply/apply.dart';


class TransformHandler {
  final Div element;

  final ComposableWidget start;

  Set<Plugin>? get plugins => element.plugins;

  TransformHandler(this.element, this.start);

  ComposableWidget run() {
    ComposableWidget? result = start;

    var transformBuilder = _buildTransform();
    if (transformBuilder != null) {
      var next = result;
      result = null;
      result = (wb) => next((c) => transformBuilder(wb));
    }

    return (wb) => result!(wb);
  }

  ComposableWidget? _buildTransform() {
    TransformP? translate = plugins?.getPluginById("transform") as TransformP?;
    if (translate == null) {
      return null;
    }

    return (wb) => Builder(
          builder: (context) => translate.getTransformedWidget(element, wb),
        );
  }

  ComposableWidget call() => run();
}
