import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class AlignItems extends Plugin {
  final List<Range> ranges = [
    Range(new RegExp(r"^items-(start|end|center|baseline|stretch)$"), 1),
  ];
  final String value;
  final String id = "alignItems";

  AlignItems([this.value = "items-center"]){
    setConfig();
    addValue(value);
  }

  @override
  AlignItems createInstance(ElementClass elementClass) => AlignItems(elementClass.value);

  CrossAxisAlignment getAlignment(){
    var value = values.values.last.asString();
    switch(value){
      case "start" : return CrossAxisAlignment.start;
      case "end" : return CrossAxisAlignment.end;
      case "center" : return CrossAxisAlignment.center;
      case "baseline" : return CrossAxisAlignment.baseline;
      case "stretch" : return CrossAxisAlignment.stretch;

      default: return CrossAxisAlignment.center;

    }
  }
}
