import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class BackgroundOpacity extends Plugin {
  final String id = "backgroundOpacity";
  final List<Range> ranges = [
    Range(new RegExp(r"^bg-opacity-\d{1,3}$"), 3),
  ];

  BackgroundOpacity([String? value]) {
    setConfig();
    addValue(value);
  }

  double getColorOpacity() => values["bg-opacity"]!.asDouble() / 100;

  @override
  BackgroundOpacity createInstance(ElementClass elementClass) => BackgroundOpacity(elementClass.value);
}
