import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class BackgroundSize extends Plugin {
  final List<Range> ranges = [
    Range(RegExp(r"^bg-(auto|cover|contain)$"), 1),
  ];
  final String value;
  final String id = "backgroundSize";

  BackgroundSize([this.value = "bg-auto"]) {
    if (value != null) {
      addValue(value);
    }
  }

  @override
  BackgroundSize createInstance(ElementClass elementClass) {
    return BackgroundSize(elementClass.value);
  }

  BoxFit getBackgroundSize() {
    var value = values.values.last.asString();
    switch (value) {
      case "auto":
        return BoxFit.fill;
      case "cover":
        return BoxFit.cover;
      case "contain":
        return BoxFit.contain;
      default:
        return BoxFit.fill;
    }
  }
}
