import 'package:apply/colors/apply_colors.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/core/regex_constants.dart';
import 'package:apply/core/value.dart';
import 'package:apply/elements/element_class.dart';
/*
* [A-Za-z]+
*
* Range(RegExp("^bg-(${RegexConstants.colors})\$"), 1),
    Range(RegExp("^bg-(${RegexConstants.colors})-(${RegexConstants.shade})\$"), 11),
* */
class BorderColor extends Plugin {
  final List<Range> ranges = [
    Range(RegExp("^border-[A-Za-z]+\$"), 1),
    Range(RegExp("^border-[A-Za-z]+-(${RegexConstants.shade})\$"), 2),
  ];
  final String? value;
  final String id = "borderColor";

  BorderColor([this.value]) {
    if (value != null) {
      addValue(value);
    }
  }

  @override
  BorderColor createInstance(ElementClass elementClass) => BorderColor(elementClass.value);

  Color getColor() {
    Color from = Colors.black.withOpacity(0.5);
    Value? valueFrom = values["border"];
    if(valueFrom != null){
      if(valueFrom.range == 1){
        from = ApplyColors.getColor(valueFrom.asString() + "-500");
      }else if(valueFrom.range == 2){
        var pair = valueFrom.asStringPair();
        from = ApplyColors.getColor("${pair.first}-${pair.last}");
      }
    }
    return from;
  }

}
