import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class FlexGrow extends Plugin {
  final List<Range> ranges = [
    Range(new RegExp(r"^flex-none$"), 3),
    Range(new RegExp(r"^flex-")),
  ];
  final String id = "flexGrow";
  final List<Range> cRanges = [
    Range(new RegExp(r"^flex-\d{1,3}$"), 1),
    Range(new RegExp(r"^flex-grow-\d{1,3}$"), 3),
  ];

  int get getValue => values["flex-none"] != null ? 0 : values["flex|flex-grow"]?.asInt() ?? 1;

  FlexGrow([String? value]) {
    setConfig();
    addValue(value);
  }

  @override
  FlexGrow createInstance(ElementClass elementClass) => FlexGrow(elementClass.value);
}
