import 'package:flutter/material.dart';
import 'package:apply/core/framework.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/div.dart';
import 'package:apply/elements/element_class.dart';
import 'package:apply/plugins/space.dart';

class FlexWrap extends Plugin {
  final String id = "flexWrap";
  final List<Range> ranges = [
    Range(new RegExp(r"^flex-wrap$")),
  ];
  String? value;

  bool get isNoWrap => value == "flex-nowrap";

  FlexWrap([String value = "flex-wrap"]) {
    addValue(value);
    setConfig();
  }

  Widget handle(Div element, BuildContext context) {
    double spaceX = 0;
    double spaceY = 0;
    Space? space = element.plugins?.getPluginById("space") as Space?;
    if (space != null) {
      var xYPair = space.xYPair();
      spaceX = xYPair.first!;
      spaceY = xYPair.last!;
    }
    return Wrap(
      children: element.children,
      spacing: spaceX,
      runSpacing: spaceY,
    );
  }

  @override
  FlexWrap createInstance(ElementClass elementClass) => FlexWrap(elementClass.value);
}
