import 'package:flutter/material.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/core/regex_constants.dart';
import 'package:apply/core/value.dart';
import 'package:apply/elements/element_class.dart';

class FontWeightP extends Plugin {
  final List<Range> ranges = [
    Range(RegExp("^font-(${RegexConstants.fontWightLabels})\$"), 1),
    Range(RegExp("^font-(${RegexConstants.fontWightNumbers})\$"), 2),
  ];

  final String? value;
  final String id = "fontWeight";
  FontWeightP([this.value]){
    if (value != null) {
      addValue(value);
    }
  }

  @override
  FontWeightP createInstance(ElementClass elementClass) {
    return FontWeightP(elementClass.value);
  }

  FontWeight getFontWeight(){
    var value = values.values.last.asString();
    FontWeight? fontWeight;

    switch(value){
      case "thin" :  fontWeight = FontWeight.w100; break;
      case "extralight" : fontWeight = FontWeight.w200; break;
      case "light" : fontWeight = FontWeight.w300; break;
      case "normal" : fontWeight = FontWeight.w400; break;
      case "medium" : fontWeight = FontWeight.w500; break;
      case "semibold" : fontWeight = FontWeight.w600; break;
      case "bold" : fontWeight = FontWeight.w700; break;
      case "extrabold" : fontWeight = FontWeight.w800; break;
      case "black" : fontWeight = FontWeight.w900; break;
      case "100" :  fontWeight = FontWeight.w100; break;
      case "200" : fontWeight = FontWeight.w200; break;
      case "300" : fontWeight = FontWeight.w300; break;
      case "400" : fontWeight = FontWeight.w400; break;
      case "500" : fontWeight = FontWeight.w500; break;
      case "600" : fontWeight = FontWeight.w600; break;
      case "700" : fontWeight = FontWeight.w700; break;
      case "800" : fontWeight = FontWeight.w800; break;
      case "900" : fontWeight = FontWeight.w900; break;
    }


    return fontWeight!;
  }

  String? side;
  String? modifier;
  Map<String, dynamic> defaultConfig = {
    'DEFAULT': '1px',
    '0': '0px',
    '2': '2px',
    '4': '4px',
    '8': '8px',
  };
}
