import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

//^/(?!ignoreme|ignoreme2|ignoremeN)([a-z0-9]+)$
//Obratiti paznju da ova fleksibilnost nedovede u koliziju sa fontweight.
class FontFamily extends Plugin {
  final List<Range> ranges = [
    Range(new RegExp(r"^font-\w"), 1),
  ];
  final String id = "fontFamily";
  final String? value;

  FontFamily([this.value]) {
    if (value != null) {
      addValue(value);
    }
  }

  @override
  FontFamily createInstance(ElementClass elementClass) {
    return FontFamily(elementClass.value);
  }

  String fontFamily() {
    String fontFamily = values["font"]!.asString();
    // print(["Font family je:", fontFamily.replaceAll("_", " ")]);
    return fontFamily.replaceAll("_", " ");
  }
}

extension StringExtension on String {
  String capitalize() {
    return "${this[0].toUpperCase()}${this.substring(1)}";
  }
}
