import 'package:flutter/material.dart';
import 'package:apply/core/config/plugin_config.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/predefined.sizes.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';


class FontSize extends Plugin  with PredefinedSizes<double> {
  final List<Range> ranges = [
    Range(RegExp(r"^text$"), 1),
    SizesRange("text"),
    SizesRangeDigit("text"),
  ];
  final String id = "fontSize";

  FontSize([String value = "text"]){
    setConfig();
    addValue(value);
  }

  @override
  FontSize createInstance(ElementClass elementClass) {
    return FontSize(elementClass.value);
  }

  double fontSize(){
    double fontSize = getValue() ?? defaultValue;
    return fontSize;
  }

  @override
  String get key => "text";

  @override
  double get noneValue => 15;

  @override
  Map<String, dynamic> defaultConfig = {
    'sizing': SizingConfig(
      xs: 10,
      sm: 12,
      base: 17,
      md: 20,
      lg: 23,
      xl: 25,
      xxl: 30,
      xxxl: 40,
      xxxxl: 45,
      xxxxxl: 55,
      xxxxxxl: 70,
    ).toJson(),
  };

  @override
  double get defaultValue => config["default"];

}
