import 'package:flutter/material.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/core/value.dart';
import 'package:apply/elements/element_class.dart';


class Height extends Plugin {
  final List<Range> ranges = [
    Range(RegExp(r"^h-\d{1,3}$"), 1),
    Range(new RegExp(r"^h-0\.\d{1,3}$"), 11),
  ];
  final String id = "height";

  Height([String? value]){
    addValue(value);
  }

  @override
  Height createInstance(ElementClass elementClass) => Height(elementClass.value);

  double getHeight(){
    if (values.hasRange([11])) {
      Value value = values[11]!;
      double height = double.parse("0.${value.value.split("h-0.").last}");
      return height;
    }
    double width = values["h"]?.asDouble() ?? 100;
    return width;
  }

}
