import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class JustifyContent extends Plugin {
  final List<Range> ranges = [
  ];
  final String value;
  final String id = "justifyContent";
  final List<String> keys = const [
    "justify-start",
    "justify-end",
    "justify-center",
    "justify-between",
    "justify-around",
    "justify-evenly",
  ];
  bool matches(String key) => keys.contains(key);

  JustifyContent([this.value = "justify-start"]);

  @override
  JustifyContent createInstance(ElementClass elementClass) {
    return JustifyContent(elementClass.value);
  }

  MainAxisAlignment getAlignment(){
    switch(value){
      case "justify-start" : return MainAxisAlignment.start;
      case "justify-end" : return MainAxisAlignment.end;
      case "justify-center" : return MainAxisAlignment.center;
      case "justify-between" : return MainAxisAlignment.spaceBetween;
      case "justify-around" : return MainAxisAlignment.spaceAround;
      case "justify-evenly" : return MainAxisAlignment.spaceEvenly;

      default: return MainAxisAlignment.start;

    }
  }
}
