import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class LetterSpacing extends Plugin {
  final String id = "letterSpacing";
  final List<Range> ranges = [
    Range(new RegExp(r"^tracking-")),
  ];
  final List<Range> cRanges = [
    Range(new RegExp(r"^tracking-\d{1,3}$"), 1),
    Range(new RegExp(r"^tracking-(tighter|tight|normal|wide|wider|widest)$"), 2),
  ];


  LetterSpacing([String? value]) {
    setConfig();
    addValue(value);
  }

  @override
  LetterSpacing createInstance(ElementClass elementClass) => LetterSpacing(elementClass.value);

  double getLetterSpacing(double fontSize){
    if(values.hasRange([1])){
      return (values["tracking"]!.asDouble() / fontSize) - 1;
    }
    if(values.hasRange([2])){
      String? value = values["tracking"]?.asString();
      switch(value){
        case "tighter" : return - fontSize * 0.05;
        case "tight" : return  - fontSize * 0.025;
        case "normal" : return  0;
        case "wide" : return  fontSize * 0.025;
        case "wider" : return  fontSize * 0.05;
        case "widest" : return  fontSize * 0.1;
      }
    }
    return  1.5;
  }
}
