import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class LineHeight extends Plugin {
  final String id = "lineHeight";
  final List<Range> ranges = [
    Range(new RegExp(r"^leading-")),
  ];
  final List<Range> cRanges = [
    Range(new RegExp(r"^leading-\d{1,3}$"), 1),
    Range(new RegExp(r"^leading-(none|tight|snug|normal|relaxed|loose)$"), 2),
  ];

  LineHeight([String? value]) {
    setConfig();
    addValue(value);
  }

  @override
  LineHeight createInstance(ElementClass elementClass) => LineHeight(elementClass.value);

  double getLineHeight(double fontSize){
    if(values.hasRange([1])){
      return values["leading"]!.asDouble() / fontSize;
    }
    if(values.hasRange([2])){
      String value = values["leading"]!.asString();
      switch(value){
        case "none" : return 1;
        case "tight" : return  1.25;
        case "snug" : return  1.375;
        case "normal" : return  1.5;
        case "relaxed" : return  1.625;
        case "loose" : return  2;
      }
    }

    return  1.5;
  }
}
