import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/core/value.dart';
import 'package:apply/elements/element_class.dart';

class Margin extends Plugin {
  final List<Range> ranges = [
    Range(RegExp(r"^(m|my|mx|mt|mr|mb|ml)-\d{1,3}$"), 1),
  ];
  final String value;
  final String id = "margin";

  Margin([this.value = "m-0"]){
    addValue(value);
  }

  @override
  Margin createInstance(ElementClass elementClass) {
    return Margin(elementClass.value);
  }

  EdgeInsets getMargin() {
    double top = values["m|my|mt"]?.asDouble() ?? 0;
    double right = values["m|mx|mr"]?.asDouble() ?? 0;
    double bottom = values["m|my|mb"]?.asDouble() ?? 0;
    double left = values["m|mx|ml"]?.asDouble() ?? 0;
    return EdgeInsets.only(top: top, right: right, bottom: bottom, left: left);
  }
}
