import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/core/value.dart';
import 'package:apply/elements/element_class.dart';
/*
*
*
*
* topLeft
topCenter
topRight
centerLeft
center
centerRight
bottomLeft

bottomCenter
bottomRight
*
* */
class ObjectPosition extends Plugin {
  final List<Range> ranges = [
    Range(new RegExp(r"^object-(left-top|center-top|right-top|left-center|center|right-center|left-bottom|center-bottom|right-bottom)$"), 1),
  ];
  final String id = "objectPosition";

  ObjectPosition([String? value]){
    setConfig();
    if (value != null) {
      addValue(value);
    }
  }

  @override
  ObjectPosition createInstance(ElementClass elementClass) => ObjectPosition(elementClass.value);

  Alignment getAlignment(){

    String value = values[1]!.value.replaceAll("object-", "");
    // print(["Alignement", value]);

    switch(value){
      case "left-top" : return Alignment.topLeft;
      case "center-top" : return Alignment.topCenter;
      case "right-top" : return Alignment.topRight;
      case "left-center" : return Alignment.centerLeft;
      case "center" : return Alignment.center;
      case "right-center" : return Alignment.centerRight;
      case "left-bottom" : return Alignment.bottomLeft;
      case "center-bottom" : return Alignment.bottomCenter;
      case "right-bottom" : return Alignment.bottomRight;
      default: return Alignment.center;
    }
  }

  Widget getAlignedWidget([Widget? child]) =>
      Align(
        alignment: getAlignment(),
        child: child,
      );
}
