import 'package:flutter/material.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/div.dart';
import 'package:apply/elements/element_class.dart';

class OpacityP extends Plugin {
  final String id = "opacity";
  final List<Range> ranges = [
    Range(new RegExp(r"^opacity-\d{1,3}$"), 1),
  ];

  OpacityP([String? value]) {
    setConfig();
    addValue(value);
  }

  Widget handle(BuildContext context, Div element, WidgetBuilder wb) {
// print(values);
    return Builder(
      builder: (c) => Opacity(
        opacity: values["opacity"]!.asDouble() / 100,
        child: wb(c),
      ),
    );
  }

  @override
  OpacityP createInstance(ElementClass elementClass) => OpacityP(elementClass.value);
}
