import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class OverflowP extends Plugin {
  final List<Range> ranges = [
  ];
  final String value;
  final String id = "overflow";
  final List<String> keys = const [
    "overflow-x-auto",
    "overflow-y-auto",
  ];

  bool matches(String key) => keys.contains(key);

  OverflowP([this.value = "overflow-y-auto"]);

  @override
  OverflowP createInstance(ElementClass elementClass) {
    return OverflowP(elementClass.value);
  }

  Axis getAxis(){
    switch(value){
      case "overflow-x-auto" : return Axis.horizontal;
      case "overflow-y-auto" : return Axis.vertical;
      default: return Axis.vertical;
    }
  }

}
