import 'package:flutter/material.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class PaddingP extends Plugin {
  final List<Range> ranges = [
    Range(RegExp(r"^(p|py|px|pt|pr|pb|pl)-\d{1,3}$"), 1),
  ];
  final String value;
  final String id = "padding";

  PaddingP([this.value = "p-0"]){
    addValue(value);
  }

  @override
  PaddingP createInstance(ElementClass elementClass) {
    return PaddingP(elementClass.value);
  }


  EdgeInsets getPadding() {
    double top = values["p|py|pt"]?.asDouble() ?? 0;
    double right = values["p|px|pr"]?.asDouble() ?? 0;
    double bottom = values["p|py|pb"]?.asDouble() ?? 0;
    double left = values["p|px|pl"]?.asDouble() ?? 0;
    return EdgeInsets.only(top: top, right: right, bottom: bottom, left: left);
  }

  Map<String, dynamic> defaultConfig = {
    'sm': '1px',
    'DEFAULT': '0px',
    'md': '2px',
    'lg': '4px',
    'xl': '8px',
    '2xl': '8px',
    'inner': '8px',
    'none': '8px',
  };
}
