import 'package:flutter/cupertino.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/core/regex_constants.dart';
import 'package:apply/elements/div.dart';
import 'package:apply/plugins/position/position_impl.dart';

abstract class Position extends Plugin {
  final List<Range> ranges = [
    Range(RegExp(r"^(absolute|relative)$"), 1),
    Range(RegExp(r"^a-(" + RegexConstants.tRBL + r")-\d{1,3}$"), 3),
  ];

  String get value;

  final String id = "position";

  static Position create() {
    return PositionImpl();
    // return PositionSecondImpl();
    // return PositionThirdImpl();
  }

  Widget handle(BuildContext context, Div element, WidgetBuilder wb);
}
