import 'package:flutter/material.dart';
import 'package:apply/core/framework.dart';
import 'package:apply/plugins/position/position.dart';

import 'package:apply/core/framework.dart';
import 'package:apply/elements/element_class.dart';
import 'package:apply/elements/div.dart';

//Ovdje kod absolute vidjeti za strane, tj. generalno hendlanje kao kod gradienta one kombinacije usvojiti
//ali ovo sve kroz prakticne primjere popravljati.
class PositionImpl extends Position {
  final String value;

  PositionImpl([this.value = "relative"]) {
    addValue(value);
  }

  @override
  PositionImpl createInstance(ElementClass elementClass) {
    return PositionImpl(elementClass.value);
  }

  Widget handle(BuildContext context, Div element, WidgetBuilder wb) {
    if (value == "relative") {
      var plus = getAbsoluteElements(element, context);
      if (plus.isEmpty) {
        return Builder(
          builder: (c) => wb(c),
        );
      }
      return Stack(
        overflow: Overflow.visible,
        children: [
          Builder(
            builder: (c) => wb(c),
          ),
          ...plus
        ],
      );
    }
    //kada funkcija u sustini nista neradi..
    return Builder(
      builder: (c) => wb(c),
    );
  }

  List<Widget> getAbsoluteElements(Div element, BuildContext context) {
    List<Widget> plus = [];
    List<int> remove = [];
    var children = element.children;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (child.hasDiv(context)) {
        Position? childPosition = child.setOwnPlugins(context)?.ownPlugins?.getPluginById("position") as Position?;
        if (childPosition != null) {
          var values = childPosition.values;
          var value = childPosition.value;
          if (value == "absolute" || (values.values.isNotEmpty && values.values.first.range == 3)) {
            double? top = values["a-tr|a-tl|a-t"]?.asDouble() ?? null;
            double? right = values["a-tr|a-br|a-r"]?.asDouble() ?? null;
            double? bottom = values["a-br|a-bl|a-b"]?.asDouble() ?? null;
            double? left = values["a-tl|a-bl|a-l"]?.asDouble() ?? null;
            var absolutePositioned = element.children[i];
            remove.insert(0,i);
            plus.add(
              Positioned(
                top: top,
                right: right,
                bottom: bottom,
                left: left,
                child: absolutePositioned,
              ),
            );
          }
        }
      }
    }
    remove.forEach((element) {
      children.removeAt(element);
    });
    // print(["Ima ih: ", plus.length]);
    return plus;
  }
}
