import 'package:flutter/material.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class TextAlignP extends Plugin {
  final String id = "textAlign";
  final List<Range> ranges = [
    Range(new RegExp(r"^text-(left|center|right|justify|start|end)$"), 1),
  ];

  TextAlignP([String? value]) {
    setConfig();
    addValue(value);
  }

  TextAlign getTextAlign() {
    String value = values["text"]!.asString();
    switch (value) {
      case "left":
        return TextAlign.left;
      case "center":
        return TextAlign.center;
      case "right":
        return TextAlign.right;
      case "justify":
        return TextAlign.justify;
      case "start":
        return TextAlign.start;
      case "end":
        return TextAlign.end;
      default:
        return TextAlign.start;
    }
  }

  @override
  TextAlignP createInstance(ElementClass elementClass) => TextAlignP(elementClass.value);
}
