import 'package:flutter/material.dart';
import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';
//Obavezno provjeriti da li rade sve ove opcija za align items i slicno.
//Ovdje no underline neradi, a posebno kreirati testi za sva ova poravnanja i slicno da se vidi da li to radi

//U layout nabiti sve do spacinga
//u repositoriju vec napraviti podjelu i sve pobrojati sa nekim minimalnim nabrajanjem, to je bitno
//kad vec prolazim kroz sve plugine.
class TextDecorationP extends Plugin {
  final String id = "textDecoration";
  final List<Range> ranges = [
    Range(new RegExp(r"^text-(underline|line-through|overline|none|no-underline)$"), 1),
  ];

  TextDecorationP([String? value]) {
    setConfig();
    addValue(value);
  }

  TextDecoration getTextDecoration() {
    String value = values["text"]!.asString();
    switch (value) {
      case "underline":
        return TextDecoration.underline;
      // case "line-through":
      case "through":
        return TextDecoration.lineThrough;
      case "overline":
        return TextDecoration.overline;
      case "none":
        return TextDecoration.none;
      case "no-underline":
        return TextDecoration.none;
      default:
        return TextDecoration.none;
    }
  }

  @override
  TextDecorationP createInstance(ElementClass elementClass) => TextDecorationP(elementClass.value);
}
