import 'package:apply/core/plugin.dart';
import 'package:apply/core/range.dart';
import 'package:apply/elements/element_class.dart';

class TextOpacity extends Plugin {
  final String id = "textOpacity";
  final List<Range> ranges = [
    Range(new RegExp(r"^text-opacity-\d{1,3}$"), 3),
  ];

  TextOpacity([String? value]) {
    setConfig();
    addValue(value);
  }

  double getColorOpacity() => values["text-opacity"]!.asDouble() / 100;

  @override
  TextOpacity createInstance(ElementClass elementClass) => TextOpacity(elementClass.value);
}
